import java.io.*;
import java.util.*;
import java.lang.Object;

public class Main{

	public static void main(String[] args){
		// Used to keep track of the millisecond for the extra credit
		long ec1, ec2, ec3, ec4, time1, time2;

		String file1, file2, file3, file4;
		mp2_1 join1;
		mp2_2 join2;
		mp2_3 join3;

		if(args.length != 4){
			System.out.println("Command line needs 4 file names.");
			System.exit(0);
		}
		
		file1 = args[0];
		file2 = args[1];
		file3 = args[2];
		file4 = args[3];

		// count1a, count2a, count3a, & count4a are the counts for the number of columns in each file.
		// count1b, count2b, count3b, & count4b are the counts for the number of rows in each file.
		int count1a = 0, count1b = 0, count2a = 0, count2b = 0, count3a = 0, count3b = 0, count4a = 0, count4b = 0;

		// implement a try-catch block just in case the file I/O has troubles...
		try{
			// Declare a buffered reader for each file.
			BufferedReader r = new BufferedReader(new FileReader(file1));
			BufferedReader r2 = new BufferedReader(new FileReader(file2));
			BufferedReader r3 = new BufferedReader(new FileReader(file3));
			BufferedReader r4 = new BufferedReader(new FileReader(file4));

			// Declare 2D arrays to hold the contents of each file and the result.
			String[][] table1;			// array to store table from file1.
			String[][] table2;			// array to store table from file2.
			String[][] table3;			// array to store table from file3.
			String[][] table4;			// array to store table from file4.
			String[][] result;			// array to store results for #1.
			String[][] result2;			// array to store results for #2.
			String[][] result3;			// array to store results for #3.
						
			// Declare 1D arrays to hold the names of each column.
			String[] columns1;
			String[] columns2;
			String[] columns3;
			String[] columns4;
			
			// These are the arrays that we are holding the columns to join on in.
			// joinOn for questions 1 and 2.  joinOnMult for #3, where we can have
			// multiple columns to join on.
			int numToJoinOn;
			int[] joinOn;
			int[][] joinOnMult;
			joinOn = new int[2];

			// Declare integers to use as a place-holders.
			int holdCol = 0, holdRow = 0, holdRow2 = 0;

			// Declare two integers to keep track of which column we are joining on.
			int joinCol1 = 0, joinCol2 = 0;
			
			// open the first file and count the # of columns and rows.
			while(r.ready()){
				String line = r.readLine();
				if(line.substring(0,1).equals("@")){
					count1a++;
				}
				else{
					count1b++;
				}
			}
			// close the first file.
			r.close();
				
			// open the second file and count the # of columns and rows.
			while(r2.ready()){
				String line = r2.readLine();
				if(line.substring(0,1).equals("@")){
					count2a++;
				}
				else{
					count2b++;
				}
	
			}
			// close the second file.
			r2.close();

			// open the second file and count the # of columns and rows.
			while(r3.ready()){
				String line = r3.readLine();
				if(line.substring(0,1).equals("@")){
					count3a++;
				}
				else{
					count3b++;
				}
	
			}
			// close the second file.
			r3.close();

			// open the second file and count the # of columns and rows.
			while(r4.ready()){
				String line = r4.readLine();
				if(line.substring(0,1).equals("@")){
					count4a++;
				}
				else{
					count4b++;
				}
	
			}
			// close the second file.
			r4.close();

			// Create the arrays to hold the column names.
			columns1 = new String[count1a];
			columns2 = new String[count2a];
			columns3 = new String[count3a];
			columns4 = new String[count4a];

			// Create the arrays to hold the tables.
			table1 = new String[count1b][count1a];
			table2 = new String[count2b][count2a];
			table3 = new String[count3b][count3a];
			table4 = new String[count4b][count4a];

			// Re-open the buffered readers.
			r = new BufferedReader(new FileReader(file1));
			r2 = new BufferedReader(new FileReader(file2));
			r3 = new BufferedReader(new FileReader(file3));
			r4 = new BufferedReader(new FileReader(file4));

			// Insert the data into table1 and columns1.
			holdRow = 0;
			holdCol = 0;
			while(r.ready()){
				String line = r.readLine();
				holdRow2 = 0;
				if(line.substring(0,1).equals("@")){
					columns1[holdCol] = line;
					holdCol++;
				}		
				else{
					StringTokenizer st = new StringTokenizer(line, " ");
					while(st.hasMoreTokens()){
						String stToken = st.nextToken();
						table1[holdRow][holdRow2] = stToken;
						holdRow2++;
					}
					holdRow++;	
				}		
			}
			r.close();
			
			// Insert the data into table2 and columns2.
			holdRow = 0;
			holdCol = 0;
			while(r2.ready()){
				String line = r2.readLine();
				holdRow2 = 0;
				if(line.substring(0,1).equals("@")){
					columns2[holdCol] = line;
					holdCol++;
				}
				else{
					StringTokenizer st = new StringTokenizer(line, " ");
					while(st.hasMoreTokens()){
						String stToken = st.nextToken();
						table2[holdRow][holdRow2] = stToken;
						holdRow2++;
					}
					holdRow++;
				}
			}

			r2.close();

			// Insert the data into table3 and columns3.
			holdRow = 0;
			holdCol = 0;
			while(r3.ready()){
				String line = r3.readLine();
				holdRow2 = 0;
				if(line.substring(0,1).equals("@")){
					columns3[holdCol] = line;
					holdCol++;
				}		
				else{
					StringTokenizer st = new StringTokenizer(line, " ");
					while(st.hasMoreTokens()){
						String stToken = st.nextToken();
						table3[holdRow][holdRow2] = stToken;
						holdRow2++;
					}
					holdRow++;	
				}		
			}
			r3.close();

			// Insert the data into table3 and columns3.
			holdRow = 0;
			holdCol = 0;
			while(r4.ready()){
				String line = r4.readLine();
				holdRow2 = 0;
				if(line.substring(0,1).equals("@")){
					columns4[holdCol] = line;
					holdCol++;
				}		
				else{
					StringTokenizer st = new StringTokenizer(line, " ");
					while(st.hasMoreTokens()){
						String stToken = st.nextToken();
						table4[holdRow][holdRow2] = stToken;
						holdRow2++;
					}
					holdRow++;	
				}		
			}
			r3.close();

			joinOn = findCommonCol(columns1, columns2);
			joinOnMult = new int[2][findNumToJoinOn(columns3, columns4)];
			joinOnMult = findCommonColumns(columns3, columns4, joinOnMult);

			// Create the arrays to hold the results.
			result = new String[count2b * count1b][count1a + count2a - 1];
			result2 = new String[count2b * count1b][count1a + count2a - 1];
			result3 = new String[count4b * count3b][count4a + count3a - joinOnMult[0].length];

			System.out.println("");
			System.out.println("");

			System.out.println("Results for MP2 #1 using " + file1 + " & " + file2);
			ec1 = System.currentTimeMillis();
			join1 = new mp2_1(table1, table2, columns1, columns2, joinOn, result);	
			ec2 = System.currentTimeMillis();
			
			System.out.println("");
			System.out.println("Results for MP2 #2 using " + file1 + " & " + file2);
			ec3 = System.currentTimeMillis();
			join2 = new mp2_2(table1, table2, columns1, columns2, joinOn, result2);
			ec4 = System.currentTimeMillis();

			System.out.println("");
			System.out.println("Results for MP2 #3 using " + file3 + " & " + file4);
			join3 = new mp2_3(table3, table4, columns3, columns4, joinOnMult, result3);

			// Figure out (& print) the time for the extra credit.
			System.out.println("");
			time1 = ec2-ec1;
			time2 = ec4-ec3;

			System.out.println("Results of the extra credit: ");
			System.out.println("The time (in milliseconds) for mp2-1 is: " + time1);
			System.out.println("The time (in milliseconds) for mp2-2 is: " + time2);
			
		}
		catch (Exception ex)
		{
			System.out.println("An exception occurred: " + ex);
			System.exit(0);
		}

	}

	private static int[] findCommonCol(String[] columns1,  String[] columns2){
		int hold1 = 0, hold2 = 0, count1, count2;
		int[] result = new int[2];
		count1 = columns1.length;
		count2 = columns2.length;
		for(hold1 = 0; hold1 < count1; hold1++){
			for(hold2 = 0; hold2 < count2; hold2++){
				if(columns1[hold1].equals(columns2[hold2])){
					result[0] = hold1;
					result[1] = hold2;
				}
			}
		}
		return result;
	}

	private static int[][] findCommonColumns(String[] columns3, String[] columns4, int[][] joinOn){
		
		// declare a variable to hold how many common variables we have found so far.
		int numVars = 0;

		// declare variables to hold the length of our columns so we don't have to keep accessing them.
		int count3, count4;

		count3 = columns3.length;
		count4 = columns4.length;

		for(int hold3 = 0; hold3 < count3; hold3++){
			for(int hold4 = 0; hold4 < count4; hold4++){
				if(columns3[hold3].equals(columns4[hold4])){
					joinOn[0][numVars] = hold3;
					joinOn[1][numVars] = hold4;
					numVars++;
				}
			}
		}

		return joinOn;
	}

	private static int findNumToJoinOn(String[] columns1, String[] columns2){
		int num = 0;
		for(int one = 0; one < columns1.length; one++){
			for(int two = 0; two < columns2.length; two++){
				if(columns1[one].equals(columns2[two])){
					num++;
				}
			}
		}

		return num;
	}
}
