import java.io.*;
import java.util.*;

public class mp2_1{

	public mp2_1(String[][] table1, String[][] table2, String[] columns1, String[] columns2, int[] joinOn, String[][] result){

			// Join the tables.
			result = nestedJoin(table1, table2, joinOn, result);

			// Print column headers.
			PrintColHeaders(columns1, columns2, joinOn);

			// Print results.
			Print(result);
	}

	private int[] findCommonCol(String[] columns1,  String[] columns2){
		int hold1 = 0, hold2 = 0, count1, count2;
		int[] result = new int[2];
		count1 = columns1.length;
		count2 = columns2.length;
		for(hold1 = 0; hold1 < count1; hold1++){
			for(hold2 = 0; hold2 < count2; hold2++){
				if(columns1[hold1].equals(columns2[hold2])){
					result[0] = hold1;
					result[1] = hold2;
				}
			}
		}
		return result;
	}

	private String[][] nestedJoin(String[][] table1, String[][] table2, int[] joinOn, String[][] result){
		int holdRow = 0, holdCol = 0;

		// Join  tables.
		for(int r = 0; r < table1.length; r++){
			for(int s = 0; s < table2.length; s++){

				// If data in field to be joined matches, insert tuple into results table.
				if(table1[r][joinOn[0]].equals(table2[s][joinOn[1]])){
					holdCol = 0;
						
					// insert tuple into results table, starting the cols from table1.
					result[holdRow][holdCol] = table1[r][joinOn[0]];
					holdCol++;
					for(int k = 0; k < table1[0].length; k++){
						if(k != joinOn[0]){
							result[holdRow][holdCol] = table1[r][k];
							holdCol++;
						}
					}

					for(int k = 0; k < table2[0].length; k++){
						if(k != joinOn[1]){
							result[holdRow][holdCol] = table2[s][k];
							holdCol++;
						}
					}
					
					// We have filled one row.  Move pointer to next row;
					holdRow++;
				}
			}
		}

		return result;
	}

	private void Print(String[][] array){
		int isnull = 0;
		// Print table.
		for(int m = 0; m < array.length; m++){
			for(int n = 0; n < array[m].length; n++){
				if(array[m][n] != null){
					System.out.print(array[m][n] + " ");
				}
				else{
					isnull = 1;
				}
			}
			if(isnull != 1){
				System.out.println("");
			}
			else{
				isnull = 0;
			}
		}
	}

	private void PrintColHeaders(String[] columns1, String[] columns2, int[] joinOn){
		System.out.println(columns1[joinOn[0]]);
		
		for(int k = 0; k < columns1.length; k++){
			if(k != joinOn[0]){
				System.out.println(columns1[k]);
			}
		}

		for(int k = 0; k < columns2.length; k++){
			if(k != joinOn[1]){
				System.out.println(columns2[k]);
			}
		}
	}
}

