public class mp2_3{
	public mp2_3(String[][] table1, String[][] table2, String[] columns1, String[] columns2, int[][] joinOn, String[][] result){

		// Join the tables.
		result = nestedJoin(table1, table2, joinOn, result);

		// Print column headers.
		PrintColHeaders(columns1, columns2, joinOn);

		// Print the result.
		Print(result);
		System.out.println("");
	}

	private String[][] nestedJoin(String[][] table1, String[][] table2, int[][] joinOn, String[][] result){
		int holdRow = 0, holdCol = 0;

		// Join  tables.
		for(int r = 0; r < table1.length; r++){
			for(int s = 0; s < table2.length; s++){

				// If data in field to be joined matches, insert tuple into results table.
				//if(table1[r][joinOn[0]].equals(table2[s][joinOn[1]])){
				if(matches(table1, table2, joinOn, r, s)){
					int length = joinOn[0].length;
					holdCol = 0;
						
					// our tuples match, so we need to add a row to the result table.
					// first, add the columns that we are joining on, then add the rest.
					for(int num = 0; num < length; num++){
						result[holdRow][holdCol] = table1[r][joinOn[0][num]];
						holdCol++;
					}

					// now, add the columns that are not being joined on.
					for(int k = 0; k < table1[0].length; k++){
						//if(k != joinOn[0]){
						if(!contains(k, joinOn[0])){
							result[holdRow][holdCol] = table1[r][k];
							holdCol++;
						}
					}

					for(int k = 0; k < table2[0].length; k++){
						//if(k != joinOn[1]){
						if(!contains(k, joinOn[1])){
							result[holdRow][holdCol] = table2[s][k];
							holdCol++;
						}
					}
					
					// We have filled one row.  Move pointer to next row;
					holdRow++;
				}
			}
		}

		return result;
	}

	private boolean contains(int column, int[] columnList){
		int length;
		length = columnList.length;
		for(int num = 0; num < length; num++){
			if ( column == columnList[num]){
				return true;
			}
		}
		return false;
	}

	private boolean matches(String[][] table1, String[][] table2, int[][] joinOn, int first, int second){
		int joined;
		joined = joinOn[0].length;

		// cycle through each column that needs to be joined on and check for matches.
		for(int one = 0; one < joined; one++){
			if(!table1[first][joinOn[0][one]].equals(table2[second][joinOn[1][one]])){
				return false;
			}
		}
		return true;
	}

	// Print the table.
	private void Print(String[][] array)
	{
		int isnull = 0;
		// Print table.
		for (int m = 0; m < array.length; m++)
		{
			for (int n = 0; n < array[m].length; n++)
			{
				if (array[m][n] != null)
				{
					System.out.print(array[m][n] + " ");
				}
				else
				{
					isnull = 1;
				}
			}
			if (isnull != 1)
			{
				System.out.println("");
			}
			else
			{
				isnull = 0;
			}
		}
	}

	//  Print the headers of the columns.
	private void PrintColHeaders(String[] columns1, String[] columns2, int[][] joinOn){

		// First, print the headers for the columns that are being joined on.
		for(int num = 0; num < joinOn[0].length; num++){
			System.out.println(columns1[joinOn[0][num]]);
		}
		
		// Then, print the headers for the rest of the columns.
		for(int k = 0; k < columns1.length; k++){
			//if(k != joinOn[0]){
			if(!contains(k, joinOn[0])){
				System.out.println(columns1[k]);
			}
		}

		for(int k = 0; k < columns2.length; k++){
			//if(k != joinOn[1]){
			if(!contains(k, joinOn[1])){
				System.out.println(columns2[k]);
			}
		}
	}
}
